%{

%}

////////////////////////////////////////////////////////////////////////////////
//Reader.h
////////////////////////////////////////////////////////////////////////////////
%ignore lucene::util::READER_ENCODING_SCHEME_LENGTH;
%ignore lucene::util::FILEREADER_CACHE;
%ignore lucene::util::FILEREADER_CACHEBUFFER;
%ignore lucene::util::FILEREADER_CACHEREMAINDER;
%ignore lucene::util::READER_ENCODING__LIST;
%ignore lucene::util::READER_ENCODING_UTF8;
%ignore lucene::util::READER_ENCODING_UCS2_LITTLE;
%ignore lucene::util::READER_ENCODING_ASCII;
/* Only expose the FileReader::close method. */
%ignore lucene::util::FileReader_ThreadUnsafe;
%ignore lucene::util::Reader::read;
%ignore lucene::util::Reader::available;
%ignore lucene::util::Reader::readChar;
%ignore lucene::util::Reader::peek;
%ignore lucene::util::Reader::position;
%ignore lucene::util::Reader::seek;

%ignore lucene::util::StringReader::StringReader ( const TCHAR* value, const size_t length, const bool deletevalue=false );
%newobject new_StringReader;
LUCENE_ADDINTCS1_CONSTRUCTOR(lucene::util::StringReader::StringReader(const TCHAR* value),1,2)


////////////////////////////////////////////////////////////////////////////////
//bitset.h
////////////////////////////////////////////////////////////////////////////////
//...

////////////////////////////////////////////////////////////////////////////////
//now include local definition
%include "local_util.i"


//now include the clucene headers
%include "CLucene/util/Reader.h"
%include "CLucene/util/BitSet.h"

#ifdef _SUMO
 %include "CLucene/util/BitVector.h"
#else
  %ignore lucene::util::Reader::read;
  %ignore lucene::util::Reader::available;
  %ignore lucene::util::Reader::readChar;
  %ignore lucene::util::Reader::peek;
  %ignore lucene::util::Reader::position;
  %ignore lucene::util::Reader::seek;
#endif
