

//csharp uses ToString, so we define here...
%rename toString ToString;

//some global ignores
%ignore *::clone; //ignore all object clone methods
%ignore *::hashCode; //todo: decide on this...ignore all object hashCode methods


//and override default Object implementations
%csmethodmodifiers toString "public override"
%{
#undef _CATCHALL
#define _CATCHALL(null_value,dummy) catch (CLuceneError& e) { \
		CL_exceptCallback(e.what(),e.number()); \
		return null_value; \
  } catch (...) { \
		char buf[250]; \
		_snprintf(buf,250,"UNKNOWN exception in %s at %d",___FILE___,___LINE___); \
		SWIG_exception(SWIG_RuntimeError,buf); \
		return null_value; \
  }
%}


